/* Linearization */
#include "RoomHeating_OM_RH_model.h"
#if defined(__cplusplus)
extern "C" {
#endif
const char *RoomHeating_OM_RH_linear_model_frame()
{
  return "model linearized_model \"RoomHeating_OM_RH\" \n  parameter Integer n = 4 \"number of states\";\n  parameter Integer m = 3 \"number of inputs\";\n  parameter Integer p = 1 \"number of outputs\";\n"
  "  parameter Real x0[n] = %s;\n"
  "  parameter Real u0[m] = %s;\n"
  "\n"
  "  parameter Real A[n, n] =\n\t[%s];\n\n"
  "  parameter Real B[n, m] =\n\t[%s];\n\n"
  "  parameter Real C[p, n] =\n\t[%s];\n\n"
  "  parameter Real D[p, m] =\n\t[%s];\n\n"
  "\n"
  "  Real x[n](start=x0);\n"
  "  input Real u[m](start=u0);\n"
  "  output Real y[p];\n"
  "\n"
  "  Real 'x_room.RAT' = x[1];\n""  Real 'x_room.energy' = x[2];\n""  Real 'x_wall.Tisurf' = x[3];\n""  Real 'x_wall.Tosurf' = x[4];\n"
  "  Real 'u_OAT' = u[1];\n""  Real 'u_fanspeed' = u[2];\n""  Real 'u_valveopen' = u[3];\n"
  "  Real 'y_RAT' = y[1];\n"
  "equation\n  der(x) = A * x + B * u;\n  y = C * x + D * u;\nend linearized_model;\n";
}
const char *RoomHeating_OM_RH_linear_model_datarecovery_frame()
{
  return "model linearized_model \"RoomHeating_OM_RH\" \n parameter Integer n = 4 \"number of states\";\n  parameter Integer m = 3 \"number of inputs\";\n  parameter Integer p = 1 \"number of outputs\";\n  parameter Integer nz = 15 \"data recovery variables\";\n"
  "  parameter Real x0[4] = %s;\n"
  "  parameter Real u0[3] = %s;\n"
  "  parameter Real z0[15] = %s;\n"
  "\n"
  "  parameter Real A[n, n] =\n\t[%s];\n\n"
  "  parameter Real B[n, m] =\n\t[%s];\n\n"
  "  parameter Real C[p, n] =\n\t[%s];\n\n"
  "  parameter Real D[p, m] =\n\t[%s];\n\n"
  "  parameter Real Cz[nz, n] =\n\t[%s];\n\n"
  "  parameter Real Dz[nz, m] =\n\t[%s];\n\n"
  "\n"
  "  Real x[n](start=x0);\n"
  "  input Real u[m](start=u0);\n"
  "  output Real y[p];\n"
  "  output Real z[nz];\n"
  "\n"
  "  Real 'x_room.RAT' = x[1];\n""  Real 'x_room.energy' = x[2];\n""  Real 'x_wall.Tisurf' = x[3];\n""  Real 'x_wall.Tosurf' = x[4];\n"
  "  Real 'u_OAT' = u[1];\n""  Real 'u_fanspeed' = u[2];\n""  Real 'u_valveopen' = u[3];\n"
  "  Real 'y_RAT' = y[1];\n"
  "  Real 'z_OAT' = z[1];\n""  Real 'z_RAT' = z[2];\n""  Real 'z_fanspeed' = z[3];\n""  Real 'z_room.DT' = z[4];\n""  Real 'z_room.EWT' = z[5];\n""  Real 'z_room.Qin' = z[6];\n""  Real 'z_room.Qout' = z[7];\n""  Real 'z_room.SAT' = z[8];\n""  Real 'z_room.fs' = z[9];\n""  Real 'z_room.mdota' = z[10];\n""  Real 'z_room.mdotw' = z[11];\n""  Real 'z_room.vo' = z[12];\n""  Real 'z_valveopen' = z[13];\n""  Real 'z_wall.C' = z[14];\n""  Real 'z_wall.R' = z[15];\n"
  "equation\n  der(x) = A * x + B * u;\n  y = C * x + D * u;\n  z = Cz * x + Dz * u;\nend linearized_model;\n";
}
#if defined(__cplusplus)
}
#endif

